package cz.moneta.test.regression.channels.digital.ib.newib.settings;

import cz.moneta.test.dsl.Harness;
import cz.moneta.test.dsl.newib.tasks.NewIbTasks;
import cz.moneta.test.dsl.newib.util.ContactsFormData;
import cz.moneta.test.dsl.util.DateUtils;
import cz.moneta.test.harness.annotations.Environment;
import cz.moneta.test.harness.annotations.JiraTestCase;
import cz.moneta.test.harness.annotations.TestCase;
import cz.moneta.test.harness.annotations.TestScenarioWithOrder;
import cz.moneta.test.harness.support.auth.Credentials;
import org.junit.jupiter.api.BeforeAll;
import org.junit.jupiter.api.Order;

@TestScenarioWithOrder(name = "Contacts tests")
public class ContactsSettingsTest {
    Credentials clientCredentials;
    ContactsFormData formData;

    private String getDate() {
        return DateUtils.getFormattedTodayDateTime("MMddHHmmss");
    }

    @BeforeAll
    public void setup(Harness harness) {
        String clientBirthNumber = harness.getConfig("nib.rc.contacts");

        clientCredentials = harness.tasks()
                .udebs()
                .findCredentialsByRC(clientBirthNumber);

        formData = ContactsFormData.builder()
                .name(getDate())
                .phoneNumber("776770770")
                .operator("Vodafone")
                .build();
    }

    @Order(1)
    @TestCase(name = "Contacts - via Settings", environments = {Environment.TST1, Environment.PPE})
    @JiraTestCase(id = "SB-T9329")
    public void newContactCreateAndDelete(Harness harness) {
        NewIbTasks newIbTasks = harness.tasks().newIb();

        harness.withNewIb()
                .openLoginPage()
                .then(newIbTasks.loginWithUsernamePasswordAndDefaultMobKey(clientCredentials.getUsername(), clientCredentials.getPassword()))
                .then(newIbTasks.createNewContactAndDeleteCreatedOne(formData));
    }
}
